libstdc++: std::_Not_fn< _Fn > Class Template Reference

libstdc++

std::_Not_fn< _Fn > Class Template Reference

`#include <functional>`

## Public Member Functions
template<typename _Fn2>
constexpr | _Not_fn (_Fn2 &&__fn, int)
| _Not_fn (_Not_fn &&__fn)=default
| _Not_fn (const _Not_fn &__fn)=default
template<typename... _Args, typename = enable_if_t<!__is_invocable<_Fn &&, _Args...>::value>>
void | operator() (_Args &&... __args) &&=delete
template<typename... _Args, typename = enable_if_t<__is_invocable<_Fn &&, _Args...>::value>>
constexpr decltype(_S_not< __inv_res_t< _Fn &&, _Args... > >()) | operator() (_Args &&... __args) &&noexcept(__is_nothrow_invocable< _Fn &&, _Args... >::value &&noexcept(_S_not< __inv_res_t< _Fn &&, _Args... > >()))
template<typename... _Args, typename = enable_if_t<!__is_invocable<_Fn &, _Args...>::value>>
void | operator() (_Args &&... __args) &=delete
template<typename... _Args, typename = enable_if_t<__is_invocable<_Fn &, _Args...>::value>>
constexpr decltype(_S_not< __inv_res_t< _Fn &, _Args... > >()) | operator() (_Args &&... __args) &noexcept(__is_nothrow_invocable< _Fn &, _Args... >::value &&noexcept(_S_not< __inv_res_t< _Fn &, _Args... > >()))
template<typename... _Args, typename = enable_if_t<!__is_invocable<_Fn const &&, _Args...>::value>>
void | operator() (_Args &&... __args) const &&=delete
template<typename... _Args, typename = enable_if_t<__is_invocable<_Fn const &&, _Args...>::value>>
constexpr decltype(_S_not< __inv_res_t< _Fn const &&, _Args... > >()) | operator() (_Args &&... __args) const &&noexcept(__is_nothrow_invocable< _Fn const &&, _Args... >::value &&noexcept(_S_not< __inv_res_t< _Fn const &&, _Args... > >()))
template<typename... _Args, typename = enable_if_t<!__is_invocable<_Fn const &, _Args...>::value>>
void | operator() (_Args &&... __args) const &=delete
template<typename... _Args, typename = enable_if_t<__is_invocable<_Fn const &, _Args...>::value>>
constexpr decltype(_S_not< __inv_res_t< _Fn const &, _Args... > >()) | operator() (_Args &&... __args) const &noexcept(__is_nothrow_invocable< _Fn const &, _Args... >::value &&noexcept(_S_not< __inv_res_t< _Fn const &, _Args... > >()))

## Detailed Description

template<typename _Fn>
class std::_Not_fn< _Fn >

Generalized negator.

Definition at line 1123 of file functional.

## Constructor & Destructor Documentation

## ◆ _Not_fn()

template<typename _Fn>
template<typename _Fn2>

std::_Not_fn< _Fn >::_Not_fn | ( | _Fn2 && | __fn,
|  | int | )
| inlineconstexpr

Definition at line 1135 of file functional.

## Member Function Documentation

## ◆ operator()() [1/4]

template<typename _Fn>
template<typename... _Args, typename = enable_if_t<__is_invocable<_Fn &&, _Args...>::value>>

decltype(_S_not< __inv_res_t< _Fn &&, _Args... > >()) std::_Not_fn< _Fn >::operator() | ( | _Args &&... | __args | ) | &&
| inlineconstexprnoexcept

Definition at line 1179 of file functional.

## ◆ operator()() [2/4]

template<typename _Fn>
template<typename... _Args, typename = enable_if_t<__is_invocable<_Fn &, _Args...>::value>>

decltype(_S_not< __inv_res_t< _Fn &, _Args... > >()) std::_Not_fn< _Fn >::operator() | ( | _Args &&... | __args | ) | &
| inlineconstexprnoexcept

Definition at line 1177 of file functional.

## ◆ operator()() [3/4]

template<typename _Fn>
template<typename... _Args, typename = enable_if_t<__is_invocable<_Fn const &&, _Args...>::value>>

decltype(_S_not< __inv_res_t< _Fn const &&, _Args... > >()) std::_Not_fn< _Fn >::operator() | ( | _Args &&... | __args | ) | const &&
| inlineconstexprnoexcept

Definition at line 1180 of file functional.

## ◆ operator()() [4/4]

template<typename _Fn>
template<typename... _Args, typename = enable_if_t<__is_invocable<_Fn const &, _Args...>::value>>

decltype(_S_not< __inv_res_t< _Fn const &, _Args... > >()) std::_Not_fn< _Fn >::operator() | ( | _Args &&... | __args | ) | const &
| inlineconstexprnoexcept

Definition at line 1178 of file functional.

The documentation for this class was generated from the following file:

- functional